<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<!--
IGAC proyecto SNC

@author 		david.cifuentes
@version 		1.0
@description 	Pantalla para gestionar la consulta y generación de reportes de radicación.
@cu				CU-NP-CO-254 Generar reporte de radicaciones
-->

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:p="http://primefaces.org/ui"
                xmlns:fn="http://java.sun.com/jsp/jstl/functions"
                xmlns:misc="http://java.sun.com/jsf/composite/misc"
                template="../../templates/generalCU.xhtml">

    <ui:define name="title">
        .::Sistema Nacional Catastral::. .::Reportes de radicación::.
    </ui:define>

    <ui:define name="content">

        <p:ajaxStatus onstart="statusDialog.show();" 
                      onsuccess="statusDialog.hide();" />

        <h:form id="gestionReporteRadicacionForm" onkeypress="return event.keyCode != 13;">

            <p:spacer height="10" />

            <p:messages id="gestionReporteRadicacionMsg" showDetail="false" globalOnly="false" />

            <h:panelGrid width="100%">

                <p:panel header="Consulta básica" id="panelconsultaBasica">

                    <p:fieldset>
                        <h:panelGrid columns="4" cellpadding="0" cellspacing="10">


                            <h:panelGrid columns="2">
                                <h:outputLabel value="Tipo reporte:"
                                               styleClass="outputLabelStyle labelRequired" />	
                            </h:panelGrid>

                            <h:panelGrid columns="2">
                                <h:selectOneMenu style="width:150px;"
                                                 value="#{gestionReporteRadicacion.tipoReporteId}"
                                                 id="tipoReporte">
                                    <f:selectItem itemLabel="Seleccionar..." />
                                    <f:selectItems
                                        value="#{gestionReporteRadicacion.tipoReportesItemList}" />
                                    <p:ajax process="@this" update=":gestionReporteRadicacionForm"
                                            onstart="statusDialog2.show();"
                                            oncomplete="statusDialog2.hide();"
                                            listener="#{gestionReporteRadicacion.cambioTipoReporte}" />
                                </h:selectOneMenu>
                                <p:message for="tipoReporte" display="icon" />
                            </h:panelGrid>

                            <h:panelGrid columns="2">
                                <h:outputLabel value="Formato:"
                                               styleClass="outputLabelStyle labelRequired" />
                            </h:panelGrid>
                            <h:panelGrid columns="2">
                                <h:selectOneMenu style="width:150px;"
                                                 value="#{gestionReporteRadicacion.formatoSeleccionado}"
                                                 id="formato" >
                                    <f:selectItem itemLabel="Seleccionar..." />
                                    <f:selectItems value="#{gestionReporteRadicacion.repFormatosDescarga}" />
                                </h:selectOneMenu>
                            </h:panelGrid>

                            <h:panelGrid columns="2">
                                <h:outputLabel value="Territorial:"
                                               styleClass="outputLabelStyle labelRequired" />
                            </h:panelGrid>
                            <h:panelGrid columns="2">
                                <h:selectOneMenu style="width:150px;"
                                                 value="#{gestionReporteRadicacion.territorialSeleccionadaCodigo}"
                                                 required="true" id="territorial" 
                                                 requiredMessage="La territorial es un campo obligatorio">
                                    <f:selectItem itemLabel="Seleccionar..." />
                                    <f:selectItems
                                        value="#{gestionReporteRadicacion.territorialesItemList}" />
                                    <p:ajax process="@this" update="uoc, departamento, municipio, rol, funcionario, panelBtn"
                                            onstart="statusDialog2.show();"
                                            oncomplete="statusDialog2.hide();"
                                            listener="#{gestionReporteRadicacion.cargarUOC}" />
                                </h:selectOneMenu>
                                <p:message for="territorial" display="icon" />
                            </h:panelGrid>

                            <h:outputLabel value="Unidades operativas de catastro:"
                                           styleClass="outputLabelStyle" />
                            <h:selectOneMenu style="width:150px;" id="uoc"
                                             value="#{gestionReporteRadicacion.unidadOperativaSeleccionadaCodigo}">
                                <f:selectItem itemLabel="Seleccionar..." itemValue="" />
                                <f:selectItems
                                    value="#{gestionReporteRadicacion.unidadesOperativasCatastroItemList}" />
                                <p:ajax process="@this" update="departamento, municipio, rol, funcionario"
                                        onstart="statusDialog2.show();"
                                        oncomplete="statusDialog2.hide();"
                                        listener="#{gestionReporteRadicacion.cargarDepartamentos}" />
                            </h:selectOneMenu>

                            <h:outputLabel value="Departamento:" styleClass="outputLabelStyle" />
                            <h:selectOneMenu id="departamento"
                                             label="Departamento" style="width:150px;"
                                             value="#{gestionReporteRadicacion.departamentoSeleccionadoCodigo}">
                                <f:selectItem itemLabel="Seleccionar..." itemValue="" />
                                <f:selectItems
                                    value="#{gestionReporteRadicacion.departamentosItemList}" />
                                <p:ajax listener="#{gestionReporteRadicacion.cargarMunicipios}"
                                        onstart="statusDialog2.show();"
                                        oncomplete="statusDialog2.hide();"
                                        update="municipio, panelBtn" />
                            </h:selectOneMenu>

                            <h:outputLabel value="Municipio:"
                                           styleClass="outputLabelStyle" />
                            <h:selectOneMenu id="municipio" label="Municipio"
                                             style="width:150px;"
                                             value="#{gestionReporteRadicacion.municipioSeleccionadoCodigo}">
                                <f:selectItem itemLabel="Seleccionar..." itemValue="" />
                                <f:selectItems
                                    value="#{gestionReporteRadicacion.municipiosItemList}" />
                            </h:selectOneMenu>

                            <h:panelGrid columns="2">
                                <h:outputLabel value="Fecha inicio:"
                                               styleClass="outputLabelStyle labelRequired" />
                            </h:panelGrid>
                            <p:calendar id="fechaInicio" effect="explode"
                                        value="#{gestionReporteRadicacion.fechaInicio}"
                                        locale="es_CO" navigator="true"
                                        label="Fecha de inicio"
                                        maxdate="#{gestionReporteRadicacion.maxDate}"
                                        mindate="#{gestionReporteRadicacion.minDate}"
                                        pattern="#{general.formatoFechaComponenteCalendar}"
                                        showOn="both" title="#{general.formatoFechaUsuario}" size="25" />

                            <h:panelGrid columns="2">
                                <h:outputLabel value="Fecha fin:" 
                                               styleClass="outputLabelStyle labelRequired" />
                            </h:panelGrid>

                            <p:calendar id="fechaFin" effect="explode"
                                        value="#{gestionReporteRadicacion.fechaFin}"
                                        locale="es_CO" navigator="true"
                                        label="Fecha fin de la consulta"
                                        maxdate="#{gestionReporteRadicacion.maxDate}"
                                        mindate="#{gestionReporteRadicacion.minDate}"
                                        pattern="#{general.formatoFechaComponenteCalendar}"
                                        showOn="both" title="#{general.formatoFechaUsuario}" size="25" />

                            <h:outputLabel value="Rol:"
                                           styleClass="outputLabelStyle" rendered="#{gestionReporteRadicacion.deshabilitaCampos}"/>
                            <h:selectOneMenu id="rol" label="Roles" style="width:150px;"
                                             value="#{gestionReporteRadicacion.rolSeleccionado}" 
                                             disabled="#{gestionReporteRadicacion.deshabilitarCamposConsultaBool}"
                                             rendered="#{gestionReporteRadicacion.deshabilitaCampos}">
                                <f:selectItem itemLabel="Seleccionar..." itemValue="" />
                                <f:selectItems
                                    value="#{gestionReporteRadicacion.rolesItemList}" />
                                <p:ajax listener="#{gestionReporteRadicacion.cargarFuncionarios}"
                                        update="funcionario" onstart="statusDialog2.show();"
                                        oncomplete="statusDialog2.hide();" />
                            </h:selectOneMenu>

                            <h:outputLabel value="Funcionario:"
                                           styleClass="outputLabelStyle" rendered="#{gestionReporteRadicacion.deshabilitaCampos}"/>
                            <h:selectOneMenu id="funcionario" label="Funcionarios"
                                             style="width:150px;" rendered="#{gestionReporteRadicacion.deshabilitaCampos}"
                                             value="#{gestionReporteRadicacion.funcionarioSeleccionado}"
                                             disabled="#{gestionReporteRadicacion.deshabilitarCamposConsultaBool}">
                                <f:selectItem itemLabel="Seleccionar..." itemValue="" />
                                <f:selectItems
                                    value="#{gestionReporteRadicacion.funcionariosItemList}" />
                            </h:selectOneMenu>

                            <h:outputLabel value="Subproceso:"
                                           styleClass="outputLabelStyle" rendered="#{gestionReporteRadicacion.deshabilitaCampos}"/>
                            <h:selectOneMenu id="subproceso" label="Subprocesos"
                                             style="width:150px;" rendered="#{gestionReporteRadicacion.deshabilitaCampos}"
                                             value="#{gestionReporteRadicacion.subprocesoSeleccionado}"
                                             disabled="#{gestionReporteRadicacion.deshabilitarCamposConsultaBool}">
                                <f:selectItem itemLabel="Seleccionar..." itemValue="" />
                                <f:selectItems
                                    value="#{gestionReporteRadicacion.subprocesosItemList}" />
                                <p:ajax listener="#{gestionReporteRadicacion.cargarActividades}"
                                        update="actividad" onstart="statusDialog2.show();"
                                        oncomplete="statusDialog2.hide();" />
                            </h:selectOneMenu>

                            <h:outputLabel value="Actividad:"
                                           styleClass="outputLabelStyle" rendered="#{gestionReporteRadicacion.deshabilitaCampos}"/>
                            <h:selectOneMenu id="actividad" label="Actividades"
                                             style="width:150px;" rendered="#{gestionReporteRadicacion.deshabilitaCampos}"
                                             value="#{gestionReporteRadicacion.actividadSeleccionada}"
                                             disabled="#{gestionReporteRadicacion.deshabilitarCamposConsultaBool}">
                                <f:selectItem itemLabel="Seleccionar..." itemValue="" />
                                <f:selectItems
                                    value="#{gestionReporteRadicacion.actividadesItemList}" />
                            </h:selectOneMenu>

                            <h:outputLabel value="Clasificación:" 
                                           styleClass="outputLabelStyle"/>
                            <h:selectOneMenu id="clasificacion" label="Clasificación"
                                             style="width:150px;"
                                             value="#{gestionReporteRadicacion.clasificacionSeleccionada}">
                                <f:selectItem itemLabel="Seleccionar..." itemValue="" />
                                <f:selectItems
                                    value="#{gestionReporteRadicacion.clasificacionesItemList}" />
                            </h:selectOneMenu>

                            <h:outputLabel value="Días transcurridos:" 
                                           styleClass="outputLabelStyle"/>
                            <h:panelGrid columns="2">
                                <h:selectOneMenu style="width:150px;"
                                                 value="#{gestionReporteRadicacion.rangoDiasTranscurridosSeleccionado}"
                                                 id="diasTranscurridos" >
                                    <f:selectItem itemLabel="Seleccionar..." />
                                    <f:selectItems value="#{general.repDiasTranscurridos}" />
                                </h:selectOneMenu>
                            </h:panelGrid>

                            <h:outputLabel value="Código del reporte:" 
                                           styleClass="outputLabelStyle"/>
                            <h:panelGrid columns="3">
                                <h:inputText id="tipoReporteCodigo"
                                             style="width:40px;"
                                             value="REP-RAD" disabled="true"
                                             title="Tipo del reporte" />
                                <h:inputText id="codigoReporteCodigo"
                                             style="width:80px;" maxlength="12"
                                             value="#{gestionReporteRadicacion.codigoReporteCod}"
                                             title="Código del reporte" />
                                <h:inputText id="anioReporteCodigo"
                                             style="width:40px;"
                                             value="#{gestionReporteRadicacion.anioReporteCod}"
                                             title="Año del reporte" />
                                <p:watermark for="anioReporteCodigo" value="AAAA" id="watermark" />
                            </h:panelGrid>

                        </h:panelGrid>

                    </p:fieldset>

                    <p:spacer height="10" width="25" />

                    <p:separator style="width:98%;height:3px" />

                    <p:spacer height="7" width="0" />

                    <p:outputPanel layout="block" style="text-align:right" id="panelBtn">

                        <p:commandButton value="Buscar" icon="ui-icon-search"
                                         onstart="statusDialog2.show()" oncomplete="statusDialog2.hide()"
                                         id="buscarReporteBtn" rendered="#{gestionReporteRadicacion.permisoBuscarReporteBool}"
                                         process="@form" actionListener="#{gestionReporteRadicacion.buscarReporte}" 
                                         update=":gestionReporteRadicacionForm"/>
                        <p:spacer height="0" width="10" />

                        <p:commandButton value="Generar" icon="ui-icon-check"
                                         id="confirmarGenerarReporteBtn" 
                                         rendered="#{gestionReporteRadicacion.permisoGenerarReporteBool 
                                                     and fn:length(gestionReporteRadicacion.reportesRadicacionGenerados) ne 0}"
                                         disabled="#{!gestionReporteRadicacion.permisoGenerarReporteBool}"
                                         oncomplete="confirmarGenerarReporteWV.show()" />
                        <p:spacer height="0" width="10" />

                        <p:commandButton value="Generar" icon="ui-icon-check"
                                         id="generarReporteBtn" update=":gestionReporteRadicacionForm"
                                         rendered="#{gestionReporteRadicacion.permisoGenerarReporteBool 
                                                     and fn:length(gestionReporteRadicacion.reportesRadicacionGenerados) eq 0}"
                                         disabled="#{!gestionReporteRadicacion.permisoGenerarReporteBool}"
                                         onstart="statusDialog2.show()" oncomplete="statusDialog2.hide()"
                                         process="@this" action="#{gestionReporteRadicacion.generarReporte}" />
                        <p:spacer height="0" width="10" />
                    </p:outputPanel>

                    <p:spacer height="7" width="0" />

                    <p:panel header="Reportes generados" id="panelReportesGenerados">

                        <p:dataTable id="tablaReportesGenerados"
                                     value="#{gestionReporteRadicacion.reportesRadicacionGenerados}"
                                     var="reporte" paginator="true" rows="20" rowKey="#{reporte.id}"
                                     paginatorPosition="bottom"
                                     selection="#{gestionReporteRadicacion.reportesSeleccionados}"
                                     paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                     rowsPerPageTemplate="10,20,50"
                                     emptyMessage="No se encontraron reportes generados">

                            <p:ajax event="rowSelect" onstart="statusDialog2.show();" oncomplete="statusDialog2.hide();"
                                    listener="#{gestionReporteRadicacion.seleccionarTodosReportes}"
                                    update=":gestionReporteRadicacionForm" />

                            <p:ajax event="rowUnselect" onstart="statusDialog2.show();" oncomplete="statusDialog2.hide();"
                                    listener="#{gestionReporteRadicacion.manejarDesactivacionDeBotones}" 
                                    update=":gestionReporteRadicacionForm"/>

                            <p:column selectionMode="Multiple">

                            </p:column>

                            <p:column headerText="Código reporte" sortBy="#{reporte.codigoReporte}">
                                <h:outputText value="#{reporte.codigoReporte}"
                                              styleClass="outputTextStyleInTable">
                                </h:outputText>
                            </p:column>

                            <p:column headerText="Territorial" sortBy="#{reporte.territorial.nombre}">
                                <h:outputText value="#{reporte.territorial.nombre}"
                                              styleClass="outputTextStyleInTable">
                                </h:outputText>
                            </p:column>

                            <p:column headerText="UOC" sortBy="#{reporte.UOC.nombre}">
                                <h:outputText value="#{reporte.UOC.nombre}"
                                              styleClass="outputTextStyleInTable">
                                </h:outputText>
                            </p:column>

                            <p:column headerText="Departamento" sortBy="#{reporte.departamentoCodigo}">
                                <h:outputText value="#{reporte.departamentoCodigo}"
                                              styleClass="outputTextStyleInTable">
                                    <f:converter converterId="converterDepartamentoNombre" />
                                </h:outputText>
                            </p:column>

                            <p:column headerText="Municipio" sortBy="#{reporte.municipioCodigo}">
                                <h:outputText value="#{reporte.municipioCodigo}"
                                              styleClass="outputTextStyleInTable">
                                    <f:converter converterId="converterMunicipioNombre" />
                                </h:outputText>
                            </p:column>

                            <p:column headerText="Tipo reporte" sortBy="#{reporte.repReporte.nombre}">
                                <h:outputText value="#{reporte.repReporte.nombre}"
                                              styleClass="outputTextStyleInTable">
                                </h:outputText>
                            </p:column>

                            <p:column headerText="Fecha inicio" sortBy="#{reporte.fechaInicio}">
                                <h:outputText value="#{reporte.fechaInicio}"
                                              styleClass="outputTextStyleInTable">

                                    <f:convertDateTime pattern="#{general.formatoFechaComponenteCalendar}"
                                                       type="date" />	
                                </h:outputText>
                            </p:column>

                            <p:column headerText="Fecha fin" sortBy="#{reporte.fechaFin}">
                                <h:outputText value="#{reporte.fechaFin}"
                                              styleClass="outputTextStyleInTable">

                                    <f:convertDateTime pattern="#{general.formatoFechaComponenteCalendar}"
                                                       type="date" />	
                                </h:outputText>
                            </p:column>

                            <p:column headerText="Fecha generación" >
                                <h:outputText value="#{reporte.fechaGeneracion}"
                                              styleClass="outputTextStyleInTable">
                                    <f:convertDateTime pattern="#{general.formatoFechaHora24}"
                                                       type="date" />
                                </h:outputText>
                            </p:column>

                            <p:column headerText="Estado" sortBy="#{reporte.estado}">
                                <h:outputText value="#{reporte.estado}"
                                              styleClass="outputTextStyleInTable">
                                </h:outputText>
                            </p:column>

                            <p:column headerText="Opciones">
                                <center>								
                                    <p:commandButton title="Ver reporte"
                                                     icon="ui-icon-search"
                                                     update=":previsualizadorReporteForm" 
                                                     styleClass="commandLinkStyleInTable"
                                                     onstart="statusDialog2.show()"
                                                     oncomplete="previsualizadorReporteWV.show();statusDialog2.hide()"
                                                     action="#{gestionReporteRadicacion.cargarPrevisualizacionReporte}"
                                                     rendered="#{reporte.estado == 'FINALIZADO' and reporte.formato == 'PDF'}">
                                        <f:setPropertyActionListener
                                            target="#{gestionReporteRadicacion.reporteVisualizacionSeleccionado}"
                                            value="#{reporte}" />
                                    </p:commandButton>
                                </center>
                                <p:commandButton title="Asociar reporte"
                                                 icon="ui-icon-pin-w"
                                                 update=":gestionReporteRadicacionForm" 
                                                 styleClass="commandLinkStyleInTable"
                                                 onstart="statusDialog2.show()"
                                                 oncomplete="statusDialog2.hide()"
                                                 action="#{gestionReporteRadicacion.asociarReporteAUsuario}"
                                                 rendered="#{reporte.estado == 'EN PROCESO' and gestionReporteRadicacion.habilitaAsociarReporteUsuario}">
                                </p:commandButton>

                            </p:column>

                        </p:dataTable>

                        <p:spacer height="7" width="0" />

                        <p:outputPanel layout="block" style="text-align:right">

                            <p:commandButton value="Actualizar" icon="ui-icon-refresh"
                                             id="actualizarBtn" onstart="statusDialog2.show()" oncomplete="statusDialog2.hide()"
                                             process="@this" actionListener="#{gestionReporteRadicacion.actualizarTabla}" 
                                             update=":gestionReporteRadicacionForm"
                                             rendered="#{gestionReporteRadicacion.banderaActualizarReporte}"/>

                            <p:spacer height="0" width="10" />

                            <p:commandButton value="Exportar" icon="ui-icon-arrowthickstop-1-s"
                                             action="#{gestionReporteRadicacion.exportarReportes}"
                                             title="Exportar reportes seleccionados" id="exportarReportesBtn"
                                             onstart="statusDialog2.show();"
                                             oncomplete="statusDialog2.hide();handleCompleteSIC(xhr, status,args, confirmacionExportacionWV, true);"
                                             update=":gestionReporteRadicacionForm"
                                             process="@form" rendered="#{gestionReporteRadicacion.banderaExportarReporte}">
                            </p:commandButton>

                        </p:outputPanel>

                        <p:spacer height="7" width="0" />
                    </p:panel>

                    <p:spacer height="7" width="0" />

                    <p:outputPanel layout="block" style="text-align:right">
                        <p:commandButton value="Cerrar" icon="ui-icon-circle-close"
                                         process="@this" action="#{gestionReporteRadicacion.cerrar}" />
                        <p:spacer height="0" width="10" />
                    </p:outputPanel>
                </p:panel>

            </h:panelGrid>

        </h:form>

        <p:dialog header="Previsualización del reporte" dynamic="true" widgetVar="previsualizadorReporteWV"
                  modal="true" appendToBody="true" resizable="true" position="center"
                  width="720">
            <h:form id="previsualizadorReporteForm">

                <h:panelGrid columns="1" width="100%" id="reportePanel">
                    <p:fieldset>
                        <h:panelGrid columns="1" width="100%">

                            <h:panelGrid columns="1">
                                <embed src="#{gestionReporteRadicacion.rutaPrevisualizacionReporte}" width="600"
                                       height="400" />
                            </h:panelGrid>
                            <p:outputPanel layout="block" style="text-align:right">

                                <p:commandButton value="Cerrar" title="Cierra esta ventana"
                                                 oncomplete="previsualizadorReporteWV.hide()"
                                                 icon="ui-icon-close" />

                            </p:outputPanel>
                        </h:panelGrid>
                    </p:fieldset>
                </h:panelGrid>
            </h:form>
        </p:dialog>

        <p:confirmDialog appendToBody="true"
                         message="Este reporte ya existe ¿Desea generarlo nuevamente?"
                         width="400" header="Confirmación" severity="alert"
                         widgetVar="confirmarGenerarReporteWV">
            <h:form>
                <p:outputPanel layout="block" style="text-align:center">
                    <p:commandButton value="Aceptar" update=":gestionReporteRadicacionForm"
                                     action="#{gestionReporteRadicacion.generarReporte}"
                                     onstart="statusDialog2.show();"
                                     oncomplete="statusDialog2.hide(); confirmarGenerarReporteWV.hide();"
                                     icon="ui-icon-check" />
                    <p:spacer width="10" />
                    <p:commandButton value="Cancelar" icon="ui-icon-close"
                                     onclick="confirmarGenerarReporteWV.hide()" type="button" />
                </p:outputPanel>
            </h:form>
        </p:confirmDialog>

        <p:confirmDialog appendToBody="true"
                         message="¿Desea descargar el archivo de exportación con los reportes?"
                         width="400" header="Confirmación"
                         widgetVar="confirmacionExportacionWV">
            <h:form>
                <p:outputPanel layout="block" style="text-align:center">
                    <p:commandButton value="Sí"
                                     id="descargarReportesBtn"
                                     onclick="confirmacionExportacionWV.hide()" icon="ui-icon-check"
                                     process="@this" ajax="false">
                        <p:fileDownload value="#{gestionReporteRadicacion.reportesDescarga}" />
                    </p:commandButton>
                    <p:commandButton value="No" icon="ui-icon-close"
                                     onclick="confirmacionExportacionWV.hide()" type="button" />
                </p:outputPanel>
            </h:form>
        </p:confirmDialog>

    </ui:define>

</ui:composition>